<?php

$p=explode(basename(_DIR_PLUGINS)."/",str_replace('\\','/',realpath(dirname(__FILE__))));
$z = explode('/',end($p));
define('_DIR_PUBEMAIL',(_DIR_PLUGINS.stripslashes($z[0])));

include_spip('inc/presentation');
include_spip('inc/texte');
charger_generer_url();

function exec_pubemail_lire()
{
  global $connect_statut, $connect_id_auteur;
  if ($connect_statut != "0minirezo" )
  {
    echo "<p><b>"._T('acces_a_la_page')."</b></p>";
    fin_page();
    exit;
  }
  benDebug ("exec_pubemail_lire");
  
	// Lecture du compte POP  consulter
	$resultat = spip_query("SELECT * FROM spip_pubemail");
	if(spip_num_rows($resultat))
	{
		$row=spip_fetch_array($resultat);
		$serveur_pop=$row['serveur_pop'];
		$port_pop=$row['port_pop'];
		$user=$row['user'];
		$password=$row['password'];
		$serveur_smtp=$row['serveur_smtp'];
		$port_smtp=$row['port_smtp'];
		$domain=$row['domain'];
		$publie=$row['publie'];
		$rubrique=$row['rubrique'];
		$purge_pop=$row['purge_pop'];
		$auteur=$row['auteur'];
		$ack=$row['acknowledge'];
	}
	else
	{
		benLog ("Impossible d'obtenir les donnes de connexion.");
		return;
	}
	
	
	// Expression utilisee pour reconnaitre un mail qui doit etre publie
	$expressionReguliere="SPIPOUNET";
	
	$mailLog="";
	
	$mbox = get_mailBox($serveur_pop, $user, $password, $port_pop);
	
	$nb_mails = imap_num_msg($mbox);
    benDebug ("nb_mails: ".$nb_mails);

	// Lecture des mails
	for($i=1; $i<=$nb_mails; $i++)
	{
		// Recuperation de l'entete
		$header = imap_headerinfo($mbox, $i, 80, 80) or die('probleme de lecture du mail');	

		// Le sujet du mail
		$subject = $header->fetchsubject;
		
		// Doit respecter l'expression rgulire
		if(strncasecmp($subject, $expressionReguliere,strlen($expressionReguliere)) != 0)
			continue;

		// Message  traiter
		$_surtitre="";
		$_titre="";
		$_soustitre="";
		$_descriptif="";
		$_chapo="";
		$_texte="";
		$_ps="";
		$_id_rubrique=$rubrique;
		if($publie==1)
			$_statut="publie";
		else
			$_statut="prop";

		benDebug ("subject: ".$subject);
		
		$_id_auteur=getAuteur($header, $auteur);
		
		// Recuperation du contenu

		// Analyse de la structure du contenu
		//$msg = imap_fetchstructure($mbox,$i);
		//print_r($msg);

		// La premire partie est le texte du message (ou  peu prs)
		$msg = imap_fetchbody($mbox,$i,1);
		$messageBody = mb_convert_encoding($msg,"UTF-8");
		benDebug ("messageBody: ".$messageBody);
		
		$_titre= getTitre($messageBody);
		$_id_rubrique = getRubrique($messageBody, $rubrique);
		$_texte = getTexte($messageBody);
		$_lang = getLang($messageBody, $_id_rubrique);
		$idMotsCles=getIdMotCle($messageBody);
			
 	    // Quelques vrifs
 	    if ($_titre=="") // ajout JLuc
 	      $_titre=trim(str_replace($expressionReguliere, "", $subject));
 	    if ($_titre=="")
		{
 	      benLog("Erreur Titre non Trouv ");
 	      continue;
 	    }

		benDebug("<h2>Sauvegarde en base</h2>");

		//Sauvegarde en base dans la table spip_article
 	    $_date=date('Y-m-d H:i:s',time());
 	    $sql="insert into spip_articles (lang,surtitre,titre,soustitre,id_rubrique,descriptif,chapo,texte,ps,statut,accepter_forum,date) ";
 	    $sql.="VALUES( '".addslashes($_lang)."','".addslashes($_surtitre)."','".addslashes($_titre)."','".addslashes($_soustitre)."',$_id_rubrique,'".addslashes($_descriptif)."','".addslashes($_chapo)."','".addslashes($_texte)."','".addslashes($_ps)."','$_statut','pos','$_date')";
 	    benDebug($sql);
 	    spip_query($sql) or die ("erreur SQL :$sql") ;

 	    //sauvegarde en base de la table spip_auteurs_articles
 	    $id_nouvel_article = spip_insert_id();
 	    $sql="INSERT INTO spip_auteurs_articles (id_auteur, id_article) VALUES ($_id_auteur, $id_nouvel_article)";
 	    benDebug($sql);
 	    spip_query($sql)  or die ("erreur SQL :$sql");       
 	      
 	    //sauvegarde en base de la table spip_mots_articles
 	    if ($idMotsCles)
		{
			reset ($idMotsCles);
			while (list(, $idMot) = each($idMotsCles))
			{
 	          $sql = "INSERT INTO spip_mots_articles (id_mot, id_article) VALUES ($idMot, $id_nouvel_article)";
 	          benDebug($sql);
 	          spip_query($sql)  or die ("erreur SQL :$sql");       
			}
		}
 	    benDebug("Article N $id_nouvel_article sauvegard");
 	    if ($purge_pop==1 )
		{
 	        benDebug("<h1>Email N$i supprim</h1> ");
 	        imap_delete($mbox, $i);
 	        imap_expunge ($mbox); 
 	    }
		
		if($ack)
		{
			// Accus de rception de l'email
			$destinataire = $header->fromaddress;
			$subject = "Publication automatique par email: rception de votre article \"".$_titre."\"";
			benDebug("<h1>Envoi d'un mail d'accus de rception</h1>");
			benDebug("Destinataire: ".$destinataire);
			
			envoyer_mail($destinataire,$subject,$_titre);
		}
	}
	
 	benLog("nombre d emails lus : ".($i-1)."");
 	//envoyer_mail(EMAIL_CONFIRMATION,"Publication automatique par Email", $mailLog);
 	benDebug("<HR><H2>Dans Spip.log:</h2>".$mailLog);	
	
	// Redirection
	header('Location: '.$_SERVER["HTTP_REFERER"]);	
}	


 	//Recuperation de l'email de l'auteur
function getAuteur ($header,$auteurParDefaut)
{
    benDebug("<H1>getAuteur</H1>");
    $auteurTrouve=false;
    $from = $header->from;
    foreach($from as $addr)
      $fromadress = $addr->mailbox.'@'.$addr->host;
 	    
    benDebug("adresse de l'expditeur : $fromadress ");
 	    
    //Recherche de l'auteur dans la base spip  partir de l'email
    $sql="SELECT id_auteur,login,nom FROM spip_auteurs WHERE email='$fromadress' ";
    $result_nombres_auteurs = spip_query($sql);
    benDebug($sql);
 	    
    while ($row = spip_fetch_array($result_nombres_auteurs))
	{
		benDebug("Auteur trouv : ". $row['id_auteur'] ."-" . $row['login'] ."-" . $row['nom'] );
 	    //s'il y en a plusieurs (possible ? ) on ne prend que le dernier
 	    $_id_auteur=$row['id_auteur'];
 	    benLog ("Auteur Email : $fromadress id_auteur:".$row['id_auteur'] ." Login:" . $row['login'] ." Nom:" . $row['nom']);
 	    $auteurTrouve=true;
 	}
 	if ($auteurTrouve==false)
	{
		benLog("Auteur non trouv, on utilise l'auteur par dfaut : id_auteur=$auteurParDefaut");
        $_id_auteur=ID_AUTEUR_PAR_DEFAUT;     
 	}
	return  $_id_auteur;
}


function getIdMotCle ($messageBody)
{
    benDebug("<H1>getIdMotCle</H1>");
    // les id des mots cls sont dans le sujet -mot:1,3,5-
	
 	if (preg_match("/(#mot-cle:)([^#]*)/", $messageBody,$res))
    {
 	    benDebug("id_mots cles tr  ouvs : ".$res[2]);
        benLog("Mot cl N".$res[2]);
        $id_mots_return=split(',',trim($res[2]));
	}
    else
	{
        benDebug("#mot-cle non trouv ");
    }
    return $id_mots_return ;
}


function getTexte ($messageBody)
{
    benDebug("<H1>getTexte</H1>");
	 
	if (preg_match("/(#texte:)([^#]*)/", $messageBody,$res))
	{
	    $_texte= $res[2];
 	    benDebug("#texte $_texte");
	}
	else
	{
	    benDebug ("#texte non trouv");
	}
	return $_texte ;
}

function getLang ($messageBody,$idRubrique)
{
  benDebug("<h1>getLang</h1> ");
  $lang="";
  if (preg_match("/(#lang:)([^#]*)/", $messageBody,$res))
  {
	$lang= trim($res[2]);
    benDebug("#lang -$lang- ");
    benLog("Lang : -$lang- ");
  }
  else
  {
    benDebug( "lang non trouve ... Tant pis on laisse tomber, mais on peux aussi chercher la langue de la rubrique ou du secteur " ) ;
  }
  return $lang ;
}

function getTitre ($messageBody)
{
    benDebug("<h1>getTitre</h1> ");
	$titre="";
	if (preg_match("/(#titre:)([^#]*)/", $messageBody,$res))
	{
	    $titre= trim($res[2]);
	    benDebug("Titre OK : $titre ");
	    benLog("Titre : $titre ");
 	}
	else
	{
	   benDebug( " #titre non trouv $messageBody " ) ;
	}
	return $titre ;
}

function getRubrique ($messageBody, $rubrique_def)
{
    benDebug("<h1>getRubrique</h1> ");
	// un mot de la rubrique est dans le sujet -rub:bla bla-
	if (preg_match("/(#rubrique:)([^#]*)/", $messageBody,$res))
	{
	    $titreRubriqueSujet=trim($res[2]);
	    benDebug("Trouv dans le mail : $titreRubriqueSujet");
	    
	    //le titre de toutes les rubriques
	    $query="SELECT id_rubrique,titre FROM spip_rubriques ";
	    $result=spip_query($query);
	    $rubrique_trouvee=false;
	    while($row=spip_fetch_array($result))
		{
	      $id_rubrique=$row['id_rubrique'];
	      $titre_rubrique=typo($row['titre']);
	      $pos=strpos( $titre_rubrique,$titreRubriqueSujet);
	        if($pos!==false)
			{
				benDebug("ON UTILISERA cette rubrique : $titre_rubrique $id_rubrique ");
				benLog("Rubrique N: $id_rubrique - $titre_rubrique");
				// si plusieurs rubriques correspondent, on prends la derniere
				$id_rubrique_return=$id_rubrique;
				$rubrique_trouvee=true;
			}
		}
		if ($rubrique_trouvee==false)
		{
 	      benDebug("[RUBRIQUE] cette partie ($titreRubriqueSujet) n'a pas t trouve dans un des titres de rubrique . La rubrique par defaut est utilise ");
 	      $id_rubrique_return=$rubrique_def;
 	    }
 	}
	else
	{
 	    benDebug ("#rubrique non trouv on utilise la rubrique par defaut ");
 	    benLog ("rubrique non trouv on utilise la rubrique par defaut : N ".$rubrique_def);
 	    $id_rubrique_return=$rubrique_def;
 	}
 	return $id_rubrique_return ;         
}

function get_mailBox($server , $user , $passwd , $port)
{
 	benDebug ("server: ".$server." user: ".$user." passwd: ".$passwd." port: ".$port);
	$mbox= imap_open("{".$server."/pop3:$port"."}", $user, $passwd) or die("Probleme : ". imap_last_error());
	return $mbox;
}

function envoyer_mail($to, $subject,$titre_article)
{
	// Lecture du compte POP  consulter
	$resultat = spip_query("SELECT * FROM spip_pubemail");
	if(spip_num_rows($resultat))
	{
		$row=spip_fetch_array($resultat);
		$serveur_pop=$row['serveur_pop'];
		$port_pop=$row['port_pop'];
		$user=$row['user'];
		$password=$row['password'];
		$serveur_smtp=$row['serveur_smtp'];
		$port_smtp=$row['port_smtp'];
		$domain=$row['domain'];
		$publie=$row['publie'];
		$rubrique=$row['rubrique'];
		$purge_pop=$row['purge_pop'];
		$auteur=$row['auteur'];
	}

	//formatage des enttes
	$entete = "From: ".$user."@".$domain."\n";
	$mail_mime = "Date: ".date("l j F Y, G:i")."\n";
	$mail_mime .= "Content-Type: text/plain; charset=iso-8859-1\n";
	$mail_mime .= "Content-Transfer-Encoding: 8bit";
	
	switch($publie)
	{
		case 0:
			$action = "Il sera publi aprs validation par l'administrateur du site.";
			break;
		case 1:
			$action = "Il a t publi automatiquement sur le site.";
			break;
	};
	$texte="Votre article \"".$titre_article."\" a bien t reu. ".$action;

	ini_set("SMTP", $serveur_smtp);
	ini_set("smtp_port", $port_smtp);
	mail($to, $subject, $texte.$attachement, $entete.$mail_mime);
}

 	function benDebug ($texte)
	{
// 	  print "$texte <BR>";
// 	  spip_log("[PUBEMAIL] $texte");
 	}
 	
	function benLog ($texte) 
	{
	  global $mailLog;
 	  spip_log("[PUBEMAIL] $texte");
 	  $mailLog.="$texte<BR>\n";
 	}

?>